%if 0%{?rhel:1}  && 0%{?rhel} <= 7
%bcond_with tests
%else
%bcond_without tests
%endif

%global _lto_cflags %{nil}

Name: bls-dash
Version: 1.2.4
Release: 1%{?dist}.3
Summary: BLS signatures in C++, using the relic toolkit
License: ASL 2.0
URL: https://github.com/dashpay/bls-signatures
Source0: https://github.com/dashpay/bls-signatures/archive/%{version}/bls-dash-%{version}.tar.gz
Patch0: bls-dash-system-sodium.patch
Patch1: bls-dash-system-relic.patch
Patch2: bls-dash-lib_install_dir.patch
Patch3: bls-dash-soversion.patch
BuildRequires: cmake3
BuildRequires: pkgconfig(gmp)
BuildRequires: pkgconfig(libsodium) >= 1.0.18
BuildRequires: cmake(relic)
%if %{with tests}
BuildRequires: pkgconfig(catch2)
%endif
%if 0%{?rhel:1}  && 0%{?rhel} <= 7
BuildRequires:  devtoolset-9
%endif

%description
Implements BLS signatures with aggregation as in Boneh, Drijvers, Neven 2018,
using relic toolkit for cryptographic primitives (pairings, EC, hashing).
The BLS12-381 curve is used.

%package devel
Summary: BLS signatures in C++, using the relic toolkit
Requires: %{name}
Requires: relic-devel

%description devel
Implements BLS signatures with aggregation as in Boneh, Drijvers, Neven 2018,
using relic toolkit for cryptographic primitives (pairings, EC, hashing).
The BLS12-381 curve is used.

%prep
%autosetup -n bls-signatures-%{version} -p1

%build
%if 0%{?rhel:1}  && 0%{?rhel} <= 7
PATH="/opt/rh/devtoolset-9/root/usr/bin:$PATH"
export PATH
%endif
%{__mkdir} build
cd build
%{cmake3} \
    -DBUILD_BLS_PYTHON_BINDINGS=0 \
    -DBUILD_BLS_TESTS=%{with tests} \
    -DBUILD_BLS_BENCHMARKS=%{with tests} \
    -DCMAKE_SYSTEM_NAME=Linux \
    ..

%{?cmake3_build}%{?!cmake3_build:%{make_build}}

%install
%if 0%{?rhel:1}  && 0%{?rhel} <= 7
PATH="/opt/rh/devtoolset-9/root/usr/bin:$PATH"
export PATH
%endif
cd build
%{?cmake3_install}%{?!cmake3_install:%{make_install}}

sed -i \
    -e 's|^\( *# *include *\)"\(relic[^/].*\)"|\1<relic/\2>|' \
    %{buildroot}%{_includedir}/bls-dash/*

%check
%if %{with tests}
cd build
%{?__cmake_builddir:cd %{__cmake_builddir}}
./src/runtest
./src/runbench
%endif

%files
%license LICENSE
%doc README.md
%{_libdir}/libbls-dash.so.*

%files devel
%license LICENSE
%doc README.md
%{_includedir}/bls-dash
%{_libdir}/libbls-dash.so
%changelog
* Wed Aug 24 2022 Oleg Girko <ol@infoserver.lv> - 1.2.4-1
- Update to 1.2.4
- Use system sodium and relic libraries
- Build dynamic libraries and install them using the proper path
* Fri May 20 2022 Oleg Girko <ol@infoserver.lv> - 1.1.0-5
- Use Developer Toolset 9 on RHEL/CentOS 7
- Disable tests on RHEL/CentOS 7 (Catch2 unavailable)
* Thu May 19 2022 Oleg Girko <ol@infoserver.lv> - 1.1.0-4
- Add patch to fix missing <memory> include
- Use %%autosetup instead of applying each patch manually
* Sat Oct 23 2021 Oleg Girko <ol@infoserver.lv> - 1.1.0-3
- Fix conditional build of tests
- Use system catch2 library instead of bundled one if possible
* Mon May 24 2021 Oleg Girko <ol@infoserver.lv> - 1.1.0-2
- Don't combine library with statically linked GMP
- Make tests conditional
* Sun May 23 2021 Oleg Girko <ol@infoserver.lv> - 1.1.0-1
- Initial import
